/*
Пример использования
Ресурса vins static routes
Ресурс позволяет:
1. Создавать static routes
2. Удалять static routes
3. Получать информацию о всех static routes в данном Vins
4. Предоставлять доступ виртуальным машинам к static routes
5. Удалять доступ виртуальным машинам к static routes

*/

#Расскомментируйте этот код,
#и внесите необходимые правки в версию и путь,
#чтобы работать с установленным вручную (не через hashicorp provider registry) провайдером
/*
terraform {
  required_providers {
    decort = {
      version = "<VERSION>"
      source  = "basis/decort/decort"
    }
  }
}
*/

provider "decort" {
  authenticator = "oauth2"
  #controller_url = <DECORT_CONTROLLER_URL>
  controller_url = "https://mr4.digitalenergy.online"
  #oauth2_url = <DECORT_SSO_URL>
  oauth2_url           = "https://sso.digitalenergy.online"
  allow_unverified_ssl = true
}

resource "decort_image_virtual" "iv" {
  #имя виртуального образа
  #обязательный параметр
  #при изменении - обновляет имя виртуального образа
  #тип - строка
  name = "iv-name"

  #ID реального образа, на который будет ссылаться виртуальный
  #обязательный параметр
  #при изменении - ссылается на другой реальный образ
  #тип - число
  link_to = 123

  #Флаг для удаления диска
  #опциональный параметр
  #тип - bool
  #permanently = false
}

output "sr" {
  value = decort_image_virtual.iv
}
